# class ActiveSupport::MessageEncryptor

MessageEncryptor is a simple way to encrypt values which get stored somewhere you don’t trust.

The cipher text and initialization vector are base64 encoded and returned to you.

This can be used in situations similar to the `MessageVerifier`, but where you don’t want users to be able to determine the value of the payload.

### Constants

OpenSSLCipherError

### Public Class Methods

new(secret, options = {}) click to toggle source

    # File lib/active_support/message_encryptor.rb, line 26
    def initialize(secret, options = {})
      unless options.is_a?(Hash)
        ActiveSupport::Deprecation.warn "The second parameter should be an options hash. Use :cipher => 'algorithm' to specify the cipher algorithm."
        options = { :cipher => options }
      end

      @secret = secret
      @cipher = options[:cipher] || 'aes-256-cbc'
      @verifier = MessageVerifier.new(@secret, :serializer => NullSerializer)
      @serializer = options[:serializer] || Marshal
    end

### Public Instance Methods

decrypt(value) click to toggle source

    # File lib/active_support/message_encryptor.rb, line 44
    def decrypt(value)
      ActiveSupport::Deprecation.warn "MessageEncryptor#decrypt is deprecated as it is not safe without a signature. "          "Please use MessageEncryptor#decrypt_and_verify instead."
      _decrypt(value)
    end

decrypt_and_verify(value) click to toggle source

Decrypt and verify a message. We need to verify the message in order to avoid padding attacks. Reference: www.limited-entropy.com/padding-oracle-attacks

    # File lib/active_support/message_encryptor.rb, line 58
    def decrypt_and_verify(value)
      _decrypt(verifier.verify(value))
    end

encrypt(value) click to toggle source

    # File lib/active_support/message_encryptor.rb, line 38
    def encrypt(value)
      ActiveSupport::Deprecation.warn "MessageEncryptor#encrypt is deprecated as it is not safe without a signature. "          "Please use MessageEncryptor#encrypt_and_sign instead."
      _encrypt(value)
    end

encrypt_and_sign(value) click to toggle source

Encrypt and sign a message. We need to sign the message in order to avoid padding attacks. Reference: www.limited-entropy.com/padding-oracle-attacks

    # File lib/active_support/message_encryptor.rb, line 52
    def encrypt_and_sign(value)
      verifier.generate(_encrypt(value))
    end